"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ViewPortList = function ViewPortList(_ref) {
  var _ref$viewPortRef = _ref.viewPortRef,
      viewPortRef = _ref$viewPortRef === void 0 ? _react.default.createRef() : _ref$viewPortRef,
      _ref$elementsCount = _ref.elementsCount,
      elementsCount = _ref$elementsCount === void 0 ? 0 : _ref$elementsCount,
      _ref$elementHeight = _ref.elementHeight,
      elementHeight = _ref$elementHeight === void 0 ? 0 : _ref$elementHeight,
      _ref$margin = _ref.margin,
      margin = _ref$margin === void 0 ? 0 : _ref$margin,
      _ref$children = _ref.children,
      children = _ref$children === void 0 ? null : _ref$children;
  var ref = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)([0, 0]),
      _useState2 = _slicedToArray(_useState, 2),
      _useState2$ = _slicedToArray(_useState2[0], 2),
      startIndex = _useState2$[0],
      endIndex = _useState2$[1],
      setIndexes = _useState2[1];

  var elementHeightWithMargin = elementHeight + margin;
  (0, _react.useEffect)(function () {
    var frameId;

    var frame = function frame() {
      if (ref.current && viewPortRef.current) {
        setIndexes(function (currentIndexes) {
          var viewPortRect = viewPortRef.current.getBoundingClientRect();
          var minElementsCount = Math.min(Math.ceil(viewPortRect.height / elementHeightWithMargin), elementsCount);
          var nextStartIndex = Math.min(Math.max(Math.floor((viewPortRect.top - ref.current.getBoundingClientRect().top + currentIndexes[0] * elementHeightWithMargin) / elementHeightWithMargin), 0), elementsCount - minElementsCount);
          var nextEndIndex = Math.min(nextStartIndex + minElementsCount, elementsCount - 1);
          return nextStartIndex === currentIndexes[0] && nextEndIndex === currentIndexes[1] ? currentIndexes : [nextStartIndex, nextEndIndex];
        });
      }

      frameId = requestAnimationFrame(frame);
    };

    frame();
    return function () {
      return cancelAnimationFrame(frameId);
    };
  }, [elementHeightWithMargin, elementsCount, viewPortRef]);
  return (0, _react.useMemo)(function () {
    if (!elementsCount || !children) {
      return false;
    }

    var result = [];
    console.log(startIndex, endIndex);

    for (var index = startIndex; index <= endIndex; ++index) {
      result.push(children({
        innerRef: index === startIndex ? ref : undefined,
        index: index,
        style: {
          marginTop: index === startIndex ? startIndex * elementHeightWithMargin : undefined,
          marginBottom: index === endIndex ? (elementsCount - 1 - endIndex) * elementHeightWithMargin : margin
        }
      }));
    }

    return result;
  }, [children, elementHeightWithMargin, elementsCount, endIndex, margin, startIndex]);
};

var _default = _react.default.memo(ViewPortList);

exports.default = _default;